#include <Servo.h>                      //Include the servo library
Servo myservo;                          //Specify Servo Name
int pos1 = 63;                          //Servo position 1
int pos2 = 36;                          //Servo position 2
int pos0 = 90;                          //Servo position 0
int pos3 = 117;                         //Servo position 3
int pos4 = 144;                         //Servo position 4
int E1 = 5;                             //Motor 1 Speed Analog Pin
int E2 = 6;                             //Motor 2 Speed Analog Pin
int M1 = 4;                             //Motor 1 Direction Digital Pin
int M2 = 7;                             //Motor 2 Direction Digital Pin
int srf1Pin = 2;                        //Pin for SRF05 #1
int srf2Pin = 3;                        //Pin for SRF05 #2
int duration1;                          //Stores duratiuon of pulse
int distance1;                          //Stores distance in cm
int duration2;                          //Stores duratiuon of pulse
int distance2;                          //Stores distance in cm
int MinDistance = 25;                   //Minimum distance in cm before robot reacts to an object  
int LeftMotorSpeed = 255;               //Default speed of left motor
int RightMotorSpeed = 255;              //Default speed of Right motor
int SlowMotor = 50;                     //Speed the motor goes when an object is detected
int StopMotor = 0;                      //Motor stood still
int move;                               //Variable to Handle Bot Direction
int robot;                              //Variable to Handle Bot Direction
int FrontEchoCount = 0;                 //Log of Received Front Echos
int LeftEchoCount = 0;                  //Log of Received Left Echos
int RightEchoCount = 0;                 //Log of Received Right Echos

void setup() {
  //Set pin modes
  pinMode(E1, OUTPUT);
  pinMode(M1, OUTPUT);
  pinMode(E2,OUTPUT);
  pinMode(M2, OUTPUT);
  myservo.attach(0);
}

void loop() {
  robot = MoveFordward();
  robot = EchoLeft();
  delay(65);
  robot = EchoRight();
  robot = React();
}

int React() {
  //Object detected in front of robot
  if (distance1 < MinDistance && distance2 < MinDistance) {
    move = MoveBackwards();
    move = TurnRight90();
    FrontEchoCount++;
  }
  
  //Object Detected on left Sensor / Right side of robot
  if (distance1 < MinDistance) {
    move = TurnLeft();
    LeftEchoCount++;
  }
  
    //Object detected on right Sensor / Left side of robot
  if (distance2 < MinDistance) {
    move = TurnRight();
    RightEchoCount++;
  } 
  
  //Object detected in front of robot more than 3 times in a row
  if (FrontEchoCount > 3 && distance1 < MinDistance && distance2 < MinDistance) {
    move = MoveBackwards();
    move = TurnLeft90();
    FrontEchoCount = 0;
  }
  
  //Object Detected on left Sensor / Right side of robot
  if (LeftEchoCount > 2 && RightEchoCount > 2) {
    move = MoveBackwardsLong();
    move = TurnLeft180();
    LeftEchoCount = 0;
    LeftEchoCount = 0;
  }
}

int EchoLeft() {
  pinMode(srf1Pin, OUTPUT);
  digitalWrite(srf1Pin, LOW);
  delayMicroseconds(2);
  digitalWrite(srf1Pin, HIGH);
  delayMicroseconds(10);
  digitalWrite(srf1Pin, LOW);
  pinMode(srf1Pin, INPUT);
  duration1 = pulseIn(srf1Pin, HIGH);
  distance1 = duration1/58; 
  return distance1;
}

int EchoRight() {
  pinMode(srf2Pin, OUTPUT);
  digitalWrite(srf2Pin, LOW);
  delayMicroseconds(2);
  digitalWrite(srf2Pin, HIGH);
  delayMicroseconds(10);
  digitalWrite(srf2Pin, LOW);
  pinMode(srf2Pin, INPUT);
  duration2 = pulseIn(srf2Pin, HIGH);
  distance2 = duration2/58;
  return distance2;
}

int MoveFordward() {
  digitalWrite(M1,HIGH);
  analogWrite(E1, LeftMotorSpeed);  
  digitalWrite(M2,HIGH);
  analogWrite(E2, RightMotorSpeed);
}

int MoveBackwards() {
  digitalWrite(M1,LOW);
  analogWrite(E1, LeftMotorSpeed);  
  digitalWrite(M2,LOW);
  analogWrite(E2, RightMotorSpeed);
  delay(500);
}

int MoveBackwardsLong() {
  digitalWrite(M1,LOW);
  analogWrite(E1, LeftMotorSpeed);  
  digitalWrite(M2,LOW);
  analogWrite(E2, RightMotorSpeed);
  delay(2000);
}

int TurnLeft() {
  digitalWrite(M1,LOW);
  analogWrite(E1, LeftMotorSpeed);
  digitalWrite(M2,HIGH);
  analogWrite(E2, RightMotorSpeed);
  delay(250);
}

int TurnLeft90() {
  digitalWrite(M1,LOW);
  analogWrite(E1, LeftMotorSpeed);
  digitalWrite(M2,HIGH);
  analogWrite(E2, RightMotorSpeed);
  delay(750);
}

int TurnLeft180() {
  digitalWrite(M1,LOW);
  analogWrite(E1, LeftMotorSpeed);
  digitalWrite(M2,HIGH);
  analogWrite(E2, RightMotorSpeed);
  delay(1500);
}

int TurnRight() {
  digitalWrite(M1,HIGH);
  analogWrite(E1, LeftMotorSpeed);
  digitalWrite(M2,LOW);
  analogWrite(E2, RightMotorSpeed);
  delay(250);
}

int TurnRight90() {
  digitalWrite(M1,HIGH);
  analogWrite(E1, LeftMotorSpeed);
  digitalWrite(M2,LOW);
  analogWrite(E2, RightMotorSpeed);
  delay(750);
}

int TurnRight180() {
  digitalWrite(M1,HIGH);
  analogWrite(E1, LeftMotorSpeed);
  digitalWrite(M2,LOW);
  analogWrite(E2, RightMotorSpeed);
  delay(1500);
}


